(* Content-type: application/vnd.wolfram.cdf.text *)

(*** Wolfram CDF File ***)
(* http://www.wolfram.com/cdf *)

(* CreatedBy='Mathematica 12.0' *)

(***************************************************************************)
(*                                                                         *)
(*                                                                         *)
(*  Under the Wolfram FreeCDF terms of use, this file and its content are  *)
(*  bound by the Creative Commons BY-SA Attribution-ShareAlike license.    *)
(*                                                                         *)
(*        For additional information concerning CDF licensing, see:        *)
(*                                                                         *)
(*         www.wolfram.com/cdf/adopting-cdf/licensing-options.html         *)
(*                                                                         *)
(*                                                                         *)
(***************************************************************************)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[      1088,         20]
NotebookDataLength[     29939,        903]
NotebookOptionsPosition[     29230,        887]
NotebookOutlinePosition[     29567,        902]
CellTagsIndexPosition[     29524,        899]
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{
Cell[TextData[StyleBox["Light Source",
 FontWeight->"Bold"]], "Text",
 CellChangeTimes->{
  3.836692935849921*^9},ExpressionUUID->"37d9c6ba-d108-4ec6-99ee-\
da8d4b15b54b"],

Cell[BoxData[
 RowBox[{
  RowBox[{"Light", "=", 
   RowBox[{"{", 
    RowBox[{"0", ",", "0", ",", "0", ",", "3"}], "}"}]}], ";"}]], "Input",
 CellLabel->
  "In[171]:=",ExpressionUUID->"a8508b61-a1ae-4d0f-b9dc-0d98427171af"],

Cell[TextData[StyleBox["Vertices",
 FontWeight->"Bold"]], "Text",
 CellChangeTimes->{3.8366863416184807`*^9, 
  3.836691968501676*^9},ExpressionUUID->"dc3a0b01-9f33-4e09-bd6a-\
eda9466e803c"],

Cell[BoxData[{
 RowBox[{
  RowBox[{"A1", "=", 
   RowBox[{"{", 
    RowBox[{"1", ",", "1", ",", "1", ",", "1"}], "}"}]}], ";"}], "\n", 
 RowBox[{
  RowBox[{"A2", "=", 
   RowBox[{"{", 
    RowBox[{"1", ",", "1", ",", "1", ",", 
     RowBox[{"-", "1"}]}], "}"}]}], ";"}], "\n", 
 RowBox[{
  RowBox[{"A3", "=", 
   RowBox[{"{", 
    RowBox[{"1", ",", "1", ",", 
     RowBox[{"-", "1"}], ",", "1"}], "}"}]}], ";"}], "\n", 
 RowBox[{
  RowBox[{"A4", "=", 
   RowBox[{"{", 
    RowBox[{"1", ",", "1", ",", 
     RowBox[{"-", "1"}], ",", 
     RowBox[{"-", "1"}]}], "}"}]}], ";"}], "\n", 
 RowBox[{
  RowBox[{"A5", "=", 
   RowBox[{"{", 
    RowBox[{"1", ",", 
     RowBox[{"-", "1"}], ",", "1", ",", "1"}], "}"}]}], ";"}], "\n", 
 RowBox[{
  RowBox[{"A6", "=", 
   RowBox[{"{", 
    RowBox[{"1", ",", 
     RowBox[{"-", "1"}], ",", "1", ",", 
     RowBox[{"-", "1"}]}], "}"}]}], ";"}], "\n", 
 RowBox[{
  RowBox[{"A7", "=", 
   RowBox[{"{", 
    RowBox[{"1", ",", 
     RowBox[{"-", "1"}], ",", 
     RowBox[{"-", "1"}], ",", "1"}], "}"}]}], ";"}], "\n", 
 RowBox[{
  RowBox[{"A8", "=", 
   RowBox[{"{", 
    RowBox[{"1", ",", 
     RowBox[{"-", "1"}], ",", 
     RowBox[{"-", "1"}], ",", 
     RowBox[{"-", "1"}]}], "}"}]}], ";"}], "\n", 
 RowBox[{
  RowBox[{"A9", "=", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"-", "1"}], ",", "1", ",", "1", ",", "1"}], "}"}]}], ";"}], "\n", 
 RowBox[{
  RowBox[{"A10", "=", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"-", "1"}], ",", "1", ",", "1", ",", 
     RowBox[{"-", "1"}]}], "}"}]}], ";"}], "\n", 
 RowBox[{
  RowBox[{"A11", "=", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"-", "1"}], ",", "1", ",", 
     RowBox[{"-", "1"}], ",", "1"}], "}"}]}], ";"}], "\n", 
 RowBox[{
  RowBox[{"A12", "=", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"-", "1"}], ",", "1", ",", 
     RowBox[{"-", "1"}], ",", 
     RowBox[{"-", "1"}]}], "}"}]}], ";"}], "\n", 
 RowBox[{
  RowBox[{"A13", "=", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"-", "1"}], ",", 
     RowBox[{"-", "1"}], ",", "1", ",", "1"}], "}"}]}], ";"}], "\n", 
 RowBox[{
  RowBox[{"A14", "=", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"-", "1"}], ",", 
     RowBox[{"-", "1"}], ",", "1", ",", 
     RowBox[{"-", "1"}]}], "}"}]}], ";"}], "\n", 
 RowBox[{
  RowBox[{"A15", "=", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"-", "1"}], ",", 
     RowBox[{"-", "1"}], ",", 
     RowBox[{"-", "1"}], ",", "1"}], "}"}]}], ";"}], "\n", 
 RowBox[{
  RowBox[{"A16", "=", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"-", "1"}], ",", 
     RowBox[{"-", "1"}], ",", 
     RowBox[{"-", "1"}], ",", 
     RowBox[{"-", "1"}]}], "}"}]}], ";"}]}], "Input",
 CellChangeTimes->{{3.836686328454756*^9, 3.836686347059593*^9}, {
  3.83668693622934*^9, 3.8366869381757402`*^9}, {3.8366905811748037`*^9, 
  3.8366905984607697`*^9}},
 CellLabel->
  "In[172]:=",ExpressionUUID->"2d1fe327-7f51-411f-8117-0df1f9df4299"],

Cell[TextData[StyleBox["",
 FontWeight->"Bold"]], "Text",
 CellChangeTimes->{3.8366863784289017`*^9, 
  3.836692921819119*^9},ExpressionUUID->"22d48124-ccd6-45b8-9e83-\
ec51f69c9905"],

Cell[BoxData[""], "Input",
 CellChangeTimes->{{3.8366906172204723`*^9, 3.836690617950762*^9}, 
   3.83669294070212*^9},
 CellLabel->
  "In[188]:=",ExpressionUUID->"8f3ca632-b6dd-42f5-947d-6bf959bc46ae"],

Cell[TextData[StyleBox["Shadows of vertices on the 3d subspace ",
 FontWeight->"Bold"]], "Text",
 CellChangeTimes->{
  3.8366864155741463`*^9, {3.836690879957108*^9, 3.836690890098454*^9}, {
   3.8366924253637953`*^9, 
   3.836692438659285*^9}},ExpressionUUID->"84fbfbbd-a4c0-4549-8056-\
a7424defe810"],

Cell[BoxData[{
 RowBox[{
  RowBox[{"B1", "=", 
   RowBox[{
    RowBox[{"(", 
     RowBox[{"Light", "+", 
      RowBox[{
       RowBox[{"(", 
        RowBox[{"Light", "-", "A1"}], ")"}], 
       RowBox[{
        RowBox[{"(", 
         RowBox[{"-", "6"}], ")"}], "/", 
        RowBox[{"(", 
         RowBox[{"3", "-", 
          RowBox[{"A1", "[", 
           RowBox[{"[", "4", "]"}], "]"}]}], ")"}]}]}]}], ")"}], "[", 
    RowBox[{"[", 
     RowBox[{"1", ";;", "3"}], "]"}], "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"B2", "=", 
   RowBox[{
    RowBox[{"(", 
     RowBox[{"Light", "+", 
      RowBox[{
       RowBox[{"(", 
        RowBox[{"Light", "-", "A2"}], ")"}], 
       RowBox[{
        RowBox[{"(", 
         RowBox[{"-", "6"}], ")"}], "/", 
        RowBox[{"(", 
         RowBox[{"3", "-", 
          RowBox[{"A2", "[", 
           RowBox[{"[", "4", "]"}], "]"}]}], ")"}]}]}]}], ")"}], "[", 
    RowBox[{"[", 
     RowBox[{"1", ";;", "3"}], "]"}], "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"B3", "=", 
   RowBox[{
    RowBox[{"(", 
     RowBox[{"Light", "+", 
      RowBox[{
       RowBox[{"(", 
        RowBox[{"Light", "-", "A3"}], ")"}], 
       RowBox[{
        RowBox[{"(", 
         RowBox[{"-", "6"}], ")"}], "/", 
        RowBox[{"(", 
         RowBox[{"3", "-", 
          RowBox[{"A3", "[", 
           RowBox[{"[", "4", "]"}], "]"}]}], ")"}]}]}]}], ")"}], "[", 
    RowBox[{"[", 
     RowBox[{"1", ";;", "3"}], "]"}], "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"B4", "=", 
   RowBox[{
    RowBox[{"(", 
     RowBox[{"Light", "+", 
      RowBox[{
       RowBox[{"(", 
        RowBox[{"Light", "-", "A4"}], ")"}], 
       RowBox[{
        RowBox[{"(", 
         RowBox[{"-", "6"}], ")"}], "/", 
        RowBox[{"(", 
         RowBox[{"3", "-", 
          RowBox[{"A4", "[", 
           RowBox[{"[", "4", "]"}], "]"}]}], ")"}]}]}]}], ")"}], "[", 
    RowBox[{"[", 
     RowBox[{"1", ";;", "3"}], "]"}], "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"B5", "=", 
   RowBox[{
    RowBox[{"(", 
     RowBox[{"Light", "+", 
      RowBox[{
       RowBox[{"(", 
        RowBox[{"Light", "-", "A5"}], ")"}], 
       RowBox[{
        RowBox[{"(", 
         RowBox[{"-", "6"}], ")"}], "/", 
        RowBox[{"(", 
         RowBox[{"3", "-", 
          RowBox[{"A5", "[", 
           RowBox[{"[", "4", "]"}], "]"}]}], ")"}]}]}]}], ")"}], "[", 
    RowBox[{"[", 
     RowBox[{"1", ";;", "3"}], "]"}], "]"}]}], ";"}], "\n", 
 RowBox[{
  RowBox[{"B6", "=", 
   RowBox[{
    RowBox[{"(", 
     RowBox[{"Light", "+", 
      RowBox[{
       RowBox[{"(", 
        RowBox[{"Light", "-", "A6"}], ")"}], 
       RowBox[{
        RowBox[{"(", 
         RowBox[{"-", "6"}], ")"}], "/", 
        RowBox[{"(", 
         RowBox[{"3", "-", 
          RowBox[{"A6", "[", 
           RowBox[{"[", "4", "]"}], "]"}]}], ")"}]}]}]}], ")"}], "[", 
    RowBox[{"[", 
     RowBox[{"1", ";;", "3"}], "]"}], "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"B7", "=", 
   RowBox[{
    RowBox[{"(", 
     RowBox[{"Light", "+", 
      RowBox[{
       RowBox[{"(", 
        RowBox[{"Light", "-", "A7"}], ")"}], 
       RowBox[{
        RowBox[{"(", 
         RowBox[{"-", "6"}], ")"}], "/", 
        RowBox[{"(", 
         RowBox[{"3", "-", 
          RowBox[{"A7", "[", 
           RowBox[{"[", "4", "]"}], "]"}]}], ")"}]}]}]}], ")"}], "[", 
    RowBox[{"[", 
     RowBox[{"1", ";;", "3"}], "]"}], "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"B8", "=", 
   RowBox[{
    RowBox[{"(", 
     RowBox[{"Light", "+", 
      RowBox[{
       RowBox[{"(", 
        RowBox[{"Light", "-", "A8"}], ")"}], 
       RowBox[{
        RowBox[{"(", 
         RowBox[{"-", "6"}], ")"}], "/", 
        RowBox[{"(", 
         RowBox[{"3", "-", 
          RowBox[{"A8", "[", 
           RowBox[{"[", "4", "]"}], "]"}]}], ")"}]}]}]}], ")"}], "[", 
    RowBox[{"[", 
     RowBox[{"1", ";;", "3"}], "]"}], "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"B9", "=", 
   RowBox[{
    RowBox[{"(", 
     RowBox[{"Light", "+", 
      RowBox[{
       RowBox[{"(", 
        RowBox[{"Light", "-", "A9"}], ")"}], 
       RowBox[{
        RowBox[{"(", 
         RowBox[{"-", "6"}], ")"}], "/", 
        RowBox[{"(", 
         RowBox[{"3", "-", 
          RowBox[{"A9", "[", 
           RowBox[{"[", "4", "]"}], "]"}]}], ")"}]}]}]}], ")"}], "[", 
    RowBox[{"[", 
     RowBox[{"1", ";;", "3"}], "]"}], "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"B10", "=", 
   RowBox[{
    RowBox[{"(", 
     RowBox[{"Light", "+", 
      RowBox[{
       RowBox[{"(", 
        RowBox[{"Light", "-", "A10"}], ")"}], 
       RowBox[{
        RowBox[{"(", 
         RowBox[{"-", "6"}], ")"}], "/", 
        RowBox[{"(", 
         RowBox[{"3", "-", 
          RowBox[{"A10", "[", 
           RowBox[{"[", "4", "]"}], "]"}]}], ")"}]}]}]}], ")"}], "[", 
    RowBox[{"[", 
     RowBox[{"1", ";;", "3"}], "]"}], "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"B11", "=", 
   RowBox[{
    RowBox[{"(", 
     RowBox[{"Light", "+", 
      RowBox[{
       RowBox[{"(", 
        RowBox[{"Light", "-", "A11"}], ")"}], 
       RowBox[{
        RowBox[{"(", 
         RowBox[{"-", "6"}], ")"}], "/", 
        RowBox[{"(", 
         RowBox[{"3", "-", 
          RowBox[{"A11", "[", 
           RowBox[{"[", "4", "]"}], "]"}]}], ")"}]}]}]}], ")"}], "[", 
    RowBox[{"[", 
     RowBox[{"1", ";;", "3"}], "]"}], "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"B12", "=", 
   RowBox[{
    RowBox[{"(", 
     RowBox[{"Light", "+", 
      RowBox[{
       RowBox[{"(", 
        RowBox[{"Light", "-", "A12"}], ")"}], 
       RowBox[{
        RowBox[{"(", 
         RowBox[{"-", "6"}], ")"}], "/", 
        RowBox[{"(", 
         RowBox[{"3", "-", 
          RowBox[{"A12", "[", 
           RowBox[{"[", "4", "]"}], "]"}]}], ")"}]}]}]}], ")"}], "[", 
    RowBox[{"[", 
     RowBox[{"1", ";;", "3"}], "]"}], "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"B13", "=", 
   RowBox[{
    RowBox[{"(", 
     RowBox[{"Light", "+", 
      RowBox[{
       RowBox[{"(", 
        RowBox[{"Light", "-", "A13"}], ")"}], 
       RowBox[{
        RowBox[{"(", 
         RowBox[{"-", "6"}], ")"}], "/", 
        RowBox[{"(", 
         RowBox[{"3", "-", 
          RowBox[{"A13", "[", 
           RowBox[{"[", "4", "]"}], "]"}]}], ")"}]}]}]}], ")"}], "[", 
    RowBox[{"[", 
     RowBox[{"1", ";;", "3"}], "]"}], "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"B14", "=", 
   RowBox[{
    RowBox[{"(", 
     RowBox[{"Light", "+", 
      RowBox[{
       RowBox[{"(", 
        RowBox[{"Light", "-", "A14"}], ")"}], 
       RowBox[{
        RowBox[{"(", 
         RowBox[{"-", "6"}], ")"}], "/", 
        RowBox[{"(", 
         RowBox[{"3", "-", 
          RowBox[{"A14", "[", 
           RowBox[{"[", "4", "]"}], "]"}]}], ")"}]}]}]}], ")"}], "[", 
    RowBox[{"[", 
     RowBox[{"1", ";;", "3"}], "]"}], "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"B15", "=", 
   RowBox[{
    RowBox[{"(", 
     RowBox[{"Light", "+", 
      RowBox[{
       RowBox[{"(", 
        RowBox[{"Light", "-", "A15"}], ")"}], 
       RowBox[{
        RowBox[{"(", 
         RowBox[{"-", "6"}], ")"}], "/", 
        RowBox[{"(", 
         RowBox[{"3", "-", 
          RowBox[{"A15", "[", 
           RowBox[{"[", "4", "]"}], "]"}]}], ")"}]}]}]}], ")"}], "[", 
    RowBox[{"[", 
     RowBox[{"1", ";;", "3"}], "]"}], "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"B16", "=", 
   RowBox[{
    RowBox[{"(", 
     RowBox[{"Light", "+", 
      RowBox[{
       RowBox[{"(", 
        RowBox[{"Light", "-", "A16"}], ")"}], 
       RowBox[{
        RowBox[{"(", 
         RowBox[{"-", "6"}], ")"}], "/", 
        RowBox[{"(", 
         RowBox[{"3", "-", 
          RowBox[{"A16", "[", 
           RowBox[{"[", "4", "]"}], "]"}]}], ")"}]}]}]}], ")"}], "[", 
    RowBox[{"[", 
     RowBox[{"1", ";;", "3"}], "]"}], "]"}]}], ";"}]}], "Input",
 CellChangeTimes->{{3.8366905943133707`*^9, 3.836690612519994*^9}, {
  3.836690684143127*^9, 3.836690684185766*^9}, {3.836690738038468*^9, 
  3.836690758591928*^9}, {3.836691042578177*^9, 3.8366910673963213`*^9}, {
  3.836691596258932*^9, 3.8366917204894342`*^9}, {3.8366917856954117`*^9, 
  3.836691833954975*^9}},
 CellLabel->
  "In[189]:=",ExpressionUUID->"e99506f6-b3ea-410d-a9c0-c064cfa803c6"],

Cell[TextData[StyleBox["Shadow edges",
 FontWeight->"Bold"]], "Text",
 CellChangeTimes->{{3.8366867110901623`*^9, 3.8366867132405987`*^9}, {
  3.836691872586938*^9, 
  3.836691874950367*^9}},ExpressionUUID->"be59ae6e-04c5-4d32-9ea0-\
1a4d8e12f2ea"],

Cell[BoxData[{
 RowBox[{
  RowBox[{"L1", "=", 
   RowBox[{"{", 
    RowBox[{"Red", ",", 
     RowBox[{"Line", "[", 
      RowBox[{"{", 
       RowBox[{"B1", ",", "B9"}], "}"}], "]"}]}], "}"}]}], ";"}], "\n", 
 RowBox[{
  RowBox[{"L2", "=", 
   RowBox[{"{", 
    RowBox[{"Red", ",", 
     RowBox[{"Line", "[", 
      RowBox[{"{", 
       RowBox[{"B1", ",", "B5"}], "}"}], "]"}]}], "}"}]}], ";"}], "\n", 
 RowBox[{
  RowBox[{"L3", "=", 
   RowBox[{"{", 
    RowBox[{"Red", ",", 
     RowBox[{"Line", "[", 
      RowBox[{"{", 
       RowBox[{"B1", ",", "B3"}], "}"}], "]"}]}], "}"}]}], ";"}], "\n", 
 RowBox[{
  RowBox[{"L4", "=", 
   RowBox[{"{", 
    RowBox[{"Red", ",", 
     RowBox[{"Line", "[", 
      RowBox[{"{", 
       RowBox[{"B1", ",", "B2"}], "}"}], "]"}]}], "}"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"L5", "=", 
   RowBox[{"{", 
    RowBox[{"Red", ",", 
     RowBox[{"Line", "[", 
      RowBox[{"{", 
       RowBox[{"B2", ",", "B10"}], "}"}], "]"}]}], "}"}]}], ";"}], "\n", 
 RowBox[{
  RowBox[{"L6", "=", 
   RowBox[{"{", 
    RowBox[{"Red", ",", 
     RowBox[{"Line", "[", 
      RowBox[{"{", 
       RowBox[{"B2", ",", "B6"}], "}"}], "]"}]}], "}"}]}], ";"}], "\n", 
 RowBox[{
  RowBox[{"L7", "=", 
   RowBox[{"{", 
    RowBox[{"Red", ",", 
     RowBox[{"Line", "[", 
      RowBox[{"{", 
       RowBox[{"B2", ",", "B4"}], "}"}], "]"}]}], "}"}]}], ";"}], "\n", 
 RowBox[{
  RowBox[{"L8", "=", 
   RowBox[{"{", 
    RowBox[{"Red", ",", 
     RowBox[{"Line", "[", 
      RowBox[{"{", 
       RowBox[{"B3", ",", "B11"}], "}"}], "]"}]}], "}"}]}], ";"}], "\n", 
 RowBox[{
  RowBox[{"L9", "=", 
   RowBox[{"{", 
    RowBox[{"Red", ",", 
     RowBox[{"Line", "[", 
      RowBox[{"{", 
       RowBox[{"B3", ",", "B7"}], "}"}], "]"}]}], "}"}]}], ";"}], "\n", 
 RowBox[{
  RowBox[{"L10", "=", 
   RowBox[{"{", 
    RowBox[{"Red", ",", 
     RowBox[{"Line", "[", 
      RowBox[{"{", 
       RowBox[{"B3", ",", "B4"}], "}"}], "]"}]}], "}"}]}], ";"}], "\n", 
 RowBox[{
  RowBox[{"L11", "=", 
   RowBox[{"{", 
    RowBox[{"Red", ",", 
     RowBox[{"Line", "[", 
      RowBox[{"{", 
       RowBox[{"B4", ",", "B12"}], "}"}], "]"}]}], "}"}]}], ";"}], "\n", 
 RowBox[{
  RowBox[{"L12", "=", 
   RowBox[{"{", 
    RowBox[{"Red", ",", 
     RowBox[{"Line", "[", 
      RowBox[{"{", 
       RowBox[{"B4", ",", "B8"}], "}"}], "]"}]}], "}"}]}], ";"}], "\n", 
 RowBox[{
  RowBox[{"L13", "=", 
   RowBox[{"{", 
    RowBox[{"Red", ",", 
     RowBox[{"Line", "[", 
      RowBox[{"{", 
       RowBox[{"B5", ",", "B13"}], "}"}], "]"}]}], "}"}]}], ";"}], "\n", 
 RowBox[{
  RowBox[{"L14", "=", 
   RowBox[{"{", 
    RowBox[{"Red", ",", 
     RowBox[{"Line", "[", 
      RowBox[{"{", 
       RowBox[{"B5", ",", "B7"}], "}"}], "]"}]}], "}"}]}], ";"}], "\n", 
 RowBox[{
  RowBox[{"L15", "=", 
   RowBox[{"{", 
    RowBox[{"Red", ",", 
     RowBox[{"Line", "[", 
      RowBox[{"{", 
       RowBox[{"B5", ",", "B6"}], "}"}], "]"}]}], "}"}]}], ";"}], "\n", 
 RowBox[{
  RowBox[{"L16", "=", 
   RowBox[{"{", 
    RowBox[{"Red", ",", 
     RowBox[{"Line", "[", 
      RowBox[{"{", 
       RowBox[{"B6", ",", "B14"}], "}"}], "]"}]}], "}"}]}], ";"}], "\n", 
 RowBox[{
  RowBox[{"L17", "=", 
   RowBox[{"{", 
    RowBox[{"Red", ",", 
     RowBox[{"Line", "[", 
      RowBox[{"{", 
       RowBox[{"B6", ",", "B8"}], "}"}], "]"}]}], "}"}]}], ";"}], "\n", 
 RowBox[{
  RowBox[{"L18", "=", 
   RowBox[{"{", 
    RowBox[{"Red", ",", 
     RowBox[{"Line", "[", 
      RowBox[{"{", 
       RowBox[{"B7", ",", "B15"}], "}"}], "]"}]}], "}"}]}], ";"}], "\n", 
 RowBox[{
  RowBox[{"L19", "=", 
   RowBox[{"{", 
    RowBox[{"Red", ",", 
     RowBox[{"Line", "[", 
      RowBox[{"{", 
       RowBox[{"B7", ",", "B8"}], "}"}], "]"}]}], "}"}]}], ";"}], "\n", 
 RowBox[{
  RowBox[{"L20", "=", 
   RowBox[{"{", 
    RowBox[{"Red", ",", 
     RowBox[{"Line", "[", 
      RowBox[{"{", 
       RowBox[{"B8", ",", "B16"}], "}"}], "]"}]}], "}"}]}], ";"}], "\n", 
 RowBox[{
  RowBox[{"L21", "=", 
   RowBox[{"{", 
    RowBox[{"Red", ",", 
     RowBox[{"Line", "[", 
      RowBox[{"{", 
       RowBox[{"B9", ",", "B13"}], "}"}], "]"}]}], "}"}]}], ";"}], "\n", 
 RowBox[{
  RowBox[{"L22", "=", 
   RowBox[{"{", 
    RowBox[{"Red", ",", 
     RowBox[{"Line", "[", 
      RowBox[{"{", 
       RowBox[{"B9", ",", "B11"}], "}"}], "]"}]}], "}"}]}], ";"}], "\n", 
 RowBox[{
  RowBox[{"L23", "=", 
   RowBox[{"{", 
    RowBox[{"Red", ",", 
     RowBox[{"Line", "[", 
      RowBox[{"{", 
       RowBox[{"B9", ",", "B10"}], "}"}], "]"}]}], "}"}]}], ";"}], "\n", 
 RowBox[{
  RowBox[{"L24", "=", 
   RowBox[{"{", 
    RowBox[{"Red", ",", 
     RowBox[{"Line", "[", 
      RowBox[{"{", 
       RowBox[{"B10", ",", "B14"}], "}"}], "]"}]}], "}"}]}], ";"}], "\n", 
 RowBox[{
  RowBox[{"L25", "=", 
   RowBox[{"{", 
    RowBox[{"Red", ",", 
     RowBox[{"Line", "[", 
      RowBox[{"{", 
       RowBox[{"B10", ",", "B12"}], "}"}], "]"}]}], "}"}]}], ";"}], "\n", 
 RowBox[{
  RowBox[{"L26", "=", 
   RowBox[{"{", 
    RowBox[{"Red", ",", 
     RowBox[{"Line", "[", 
      RowBox[{"{", 
       RowBox[{"B11", ",", "B15"}], "}"}], "]"}]}], "}"}]}], ";"}], "\n", 
 RowBox[{
  RowBox[{"L27", "=", 
   RowBox[{"{", 
    RowBox[{"Red", ",", 
     RowBox[{"Line", "[", 
      RowBox[{"{", 
       RowBox[{"B11", ",", "B12"}], "}"}], "]"}]}], "}"}]}], ";"}], "\n", 
 RowBox[{
  RowBox[{"L28", "=", 
   RowBox[{"{", 
    RowBox[{"Red", ",", 
     RowBox[{"Line", "[", 
      RowBox[{"{", 
       RowBox[{"B12", ",", "B16"}], "}"}], "]"}]}], "}"}]}], ";"}], "\n", 
 RowBox[{
  RowBox[{"L29", "=", 
   RowBox[{"{", 
    RowBox[{"Red", ",", 
     RowBox[{"Line", "[", 
      RowBox[{"{", 
       RowBox[{"B13", ",", "B15"}], "}"}], "]"}]}], "}"}]}], ";"}], "\n", 
 RowBox[{
  RowBox[{"L30", "=", 
   RowBox[{"{", 
    RowBox[{"Red", ",", 
     RowBox[{"Line", "[", 
      RowBox[{"{", 
       RowBox[{"B13", ",", "B14"}], "}"}], "]"}]}], "}"}]}], ";"}], "\n", 
 RowBox[{
  RowBox[{"L31", "=", 
   RowBox[{"{", 
    RowBox[{"Red", ",", 
     RowBox[{"Line", "[", 
      RowBox[{"{", 
       RowBox[{"B14", ",", "B16"}], "}"}], "]"}]}], "}"}]}], ";"}], "\n", 
 RowBox[{
  RowBox[{"L32", "=", 
   RowBox[{"{", 
    RowBox[{"Red", ",", 
     RowBox[{"Line", "[", 
      RowBox[{"{", 
       RowBox[{"B15", ",", "B16"}], "}"}], "]"}]}], "}"}]}], ";"}]}], "Input",\

 CellChangeTimes->{{3.748023114247183*^9, 3.748023161574934*^9}, {
   3.748023193034977*^9, 3.748023223180923*^9}, {3.748023373887908*^9, 
   3.748023389152381*^9}, {3.7480234224603367`*^9, 3.748023468667596*^9}, {
   3.748023501095705*^9, 3.748023570619475*^9}, {3.748023607923168*^9, 
   3.748023617915889*^9}, {3.748023683813265*^9, 3.748023747172076*^9}, {
   3.748024217476131*^9, 3.7480242618894453`*^9}, 3.748024301399795*^9, 
   3.748024344924733*^9, {3.748024439588109*^9, 3.748024470637578*^9}, {
   3.74802457493194*^9, 3.748024872078638*^9}, {3.748024967385879*^9, 
   3.7480249753499928`*^9}, {3.7480250081808653`*^9, 3.748025062582705*^9}, {
   3.748025100199295*^9, 3.7480251367492247`*^9}, {3.748025237319455*^9, 
   3.748025292984845*^9}, {3.748025448107484*^9, 3.7480256721499367`*^9}, {
   3.7480257335143223`*^9, 3.748025999397748*^9}, {3.748026241070249*^9, 
   3.748026257165758*^9}, {3.748026304572529*^9, 3.748026314238723*^9}, 
   3.748026415122643*^9, {3.748028392677527*^9, 3.748028401857006*^9}, {
   3.7480284490021257`*^9, 3.748028512595089*^9}, 3.748029003670391*^9, {
   3.748029038242025*^9, 3.748029127051269*^9}, {3.7480303186713667`*^9, 
   3.748030324975483*^9}, {3.748030355948543*^9, 3.7480303920173264`*^9}, {
   3.74803044362131*^9, 3.7480305751819363`*^9}, {3.74806394076853*^9, 
   3.748063970324692*^9}, {3.7480640541304197`*^9, 3.748064055367394*^9}, {
   3.76400497059757*^9, 3.7640049734289618`*^9}, {3.76400505328977*^9, 
   3.7640050823247013`*^9}, {3.764005501227497*^9, 3.7640056302368717`*^9}, 
   3.8366863154578857`*^9, {3.836686363265745*^9, 3.836686419343253*^9}, 
   3.836686486310238*^9, 3.8366867234170218`*^9, {3.836690594343377*^9, 
   3.836690594390398*^9}, {3.83669075859582*^9, 3.8366907588695307`*^9}, {
   3.836691079106248*^9, 3.836691123837677*^9}, 3.836691394631316*^9, 
   3.8366921551016273`*^9, {3.836692206601119*^9, 3.836692247655854*^9}, {
   3.836692367667041*^9, 3.836692393714837*^9}, {3.836692986437697*^9, 
   3.836692987742556*^9}, {3.836695838175086*^9, 3.836695857617013*^9}},
 CellLabel->
  "In[205]:=",ExpressionUUID->"5362201a-5384-4659-bc9a-5cade5c05927"],

Cell[TextData[{
 StyleBox["Light rays",
  FontWeight->"Bold"],
 " (cannot be displayed in 3d)\n\n\n\n\n\n\n"
}], "Text",
 CellChangeTimes->{{3.836692168535268*^9, 3.836692190942892*^9}, {
  3.836693019344399*^9, 
  3.8366930269906673`*^9}},ExpressionUUID->"d35792fe-bfc0-4a4f-8740-\
18b63cbd32aa"],

Cell[TextData[{
 StyleBox["4D Cube edges  ",
  FontWeight->"Bold"],
 "(cannot be displayed in 3d)\n\n\n\n\n\n\n\n\n\n\n\n"
}], "Text",
 CellChangeTimes->{{3.836693015763831*^9, 
  3.836693069251305*^9}},ExpressionUUID->"7c9f043e-9912-49ea-8715-\
f7290f898a56"],

Cell[TextData[StyleBox["Display graphics",
 FontWeight->"Bold"]], "Text",
 CellChangeTimes->{
  3.8366930625422297`*^9},ExpressionUUID->"89262654-c7e3-4a1f-bb16-\
ae00bf006708"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Graphics3D", "[", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{
    "Thick", ",", "L1", ",", "L2", ",", "L3", ",", "L4", ",", "L5", ",", "L6",
      ",", "L7", ",", "L8", ",", "L9", ",", "L10", ",", "L11", ",", "L12", 
     ",", "L13", ",", "L14", ",", "L15", ",", "L16", ",", "L17", ",", "L18", 
     ",", "L19", ",", "L20", ",", "L21", ",", "L22", ",", "L23", ",", "L24", 
     ",", "L25", ",", "L26", ",", "L27", ",", "L28", ",", "L29", ",", "L30", 
     ",", "L31", ",", "L32"}], "}"}], ",", 
   RowBox[{"Boxed", "\[Rule]", "False"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.836692269335504*^9, 3.836692289168931*^9}},
 CellLabel->
  "In[237]:=",ExpressionUUID->"f11e62c9-e2fd-4428-9e5b-e30e5cb0071e"],

Cell[BoxData[
 Graphics3DBox[
  {Thickness[Large], 
   {RGBColor[1, 0, 0], Line3DBox[{{3, 3, 3}, {-3, 3, 3}}]}, 
   {RGBColor[1, 0, 0], Line3DBox[{{3, 3, 3}, {3, -3, 3}}]}, 
   {RGBColor[1, 0, 0], Line3DBox[{{3, 3, 3}, {3, 3, -3}}]}, 
   {RGBColor[1, 0, 0], 
    Line3DBox[
     NCache[{{3, 3, 3}, {Rational[3, 2], Rational[3, 2], Rational[3, 2]}}, {{
       3, 3, 3}, {1.5, 1.5, 1.5}}]]}, 
   {RGBColor[1, 0, 0], 
    Line3DBox[
     NCache[{{Rational[3, 2], Rational[3, 2], Rational[3, 2]}, {
       Rational[-3, 2], Rational[3, 2], Rational[3, 2]}}, {{1.5, 1.5, 
      1.5}, {-1.5, 1.5, 1.5}}]]}, 
   {RGBColor[1, 0, 0], 
    Line3DBox[
     NCache[{{Rational[3, 2], Rational[3, 2], Rational[3, 2]}, {
       Rational[3, 2], Rational[-3, 2], Rational[3, 2]}}, {{1.5, 1.5, 1.5}, {
      1.5, -1.5, 1.5}}]]}, 
   {RGBColor[1, 0, 0], 
    Line3DBox[
     NCache[{{Rational[3, 2], Rational[3, 2], Rational[3, 2]}, {
       Rational[3, 2], Rational[3, 2], Rational[-3, 2]}}, {{1.5, 1.5, 1.5}, {
      1.5, 1.5, -1.5}}]]}, 
   {RGBColor[1, 0, 0], Line3DBox[{{3, 3, -3}, {-3, 3, -3}}]}, 
   {RGBColor[1, 0, 0], Line3DBox[{{3, 3, -3}, {3, -3, -3}}]}, 
   {RGBColor[1, 0, 0], 
    Line3DBox[
     NCache[{{3, 3, -3}, {
       Rational[3, 2], Rational[3, 2], Rational[-3, 2]}}, {{3, 3, -3}, {1.5, 
       1.5, -1.5}}]]}, 
   {RGBColor[1, 0, 0], 
    Line3DBox[
     NCache[{{Rational[3, 2], Rational[3, 2], Rational[-3, 2]}, {
       Rational[-3, 2], Rational[3, 2], Rational[-3, 2]}}, {{1.5, 
      1.5, -1.5}, {-1.5, 1.5, -1.5}}]]}, 
   {RGBColor[1, 0, 0], 
    Line3DBox[
     NCache[{{Rational[3, 2], Rational[3, 2], Rational[-3, 2]}, {
       Rational[3, 2], Rational[-3, 2], Rational[-3, 2]}}, {{1.5, 
      1.5, -1.5}, {1.5, -1.5, -1.5}}]]}, 
   {RGBColor[1, 0, 0], Line3DBox[{{3, -3, 3}, {-3, -3, 3}}]}, 
   {RGBColor[1, 0, 0], Line3DBox[{{3, -3, 3}, {3, -3, -3}}]}, 
   {RGBColor[1, 0, 0], 
    Line3DBox[
     NCache[{{3, -3, 3}, {
       Rational[3, 2], Rational[-3, 2], Rational[3, 2]}}, {{3, -3, 3}, {
       1.5, -1.5, 1.5}}]]}, 
   {RGBColor[1, 0, 0], 
    Line3DBox[
     NCache[{{Rational[3, 2], Rational[-3, 2], Rational[3, 2]}, {
       Rational[-3, 2], Rational[-3, 2], Rational[3, 2]}}, {{1.5, -1.5, 
      1.5}, {-1.5, -1.5, 1.5}}]]}, 
   {RGBColor[1, 0, 0], 
    Line3DBox[
     NCache[{{Rational[3, 2], Rational[-3, 2], Rational[3, 2]}, {
       Rational[3, 2], Rational[-3, 2], Rational[-3, 2]}}, {{1.5, -1.5, 
      1.5}, {1.5, -1.5, -1.5}}]]}, 
   {RGBColor[1, 0, 0], Line3DBox[{{3, -3, -3}, {-3, -3, -3}}]}, 
   {RGBColor[1, 0, 0], 
    Line3DBox[
     NCache[{{3, -3, -3}, {
       Rational[3, 2], Rational[-3, 2], Rational[-3, 2]}}, {{3, -3, -3}, {
       1.5, -1.5, -1.5}}]]}, 
   {RGBColor[1, 0, 0], 
    Line3DBox[
     NCache[{{Rational[3, 2], Rational[-3, 2], Rational[-3, 2]}, {
       Rational[-3, 2], Rational[-3, 2], Rational[-3, 2]}}, {{
      1.5, -1.5, -1.5}, {-1.5, -1.5, -1.5}}]]}, 
   {RGBColor[1, 0, 0], Line3DBox[{{-3, 3, 3}, {-3, -3, 3}}]}, 
   {RGBColor[1, 0, 0], Line3DBox[{{-3, 3, 3}, {-3, 3, -3}}]}, 
   {RGBColor[1, 0, 0], 
    Line3DBox[
     NCache[{{-3, 3, 3}, {
       Rational[-3, 2], Rational[3, 2], Rational[3, 2]}}, {{-3, 3, 3}, {-1.5, 
       1.5, 1.5}}]]}, 
   {RGBColor[1, 0, 0], 
    Line3DBox[
     NCache[{{Rational[-3, 2], Rational[3, 2], Rational[3, 2]}, {
       Rational[-3, 2], Rational[-3, 2], Rational[3, 2]}}, {{-1.5, 1.5, 
      1.5}, {-1.5, -1.5, 1.5}}]]}, 
   {RGBColor[1, 0, 0], 
    Line3DBox[
     NCache[{{Rational[-3, 2], Rational[3, 2], Rational[3, 2]}, {
       Rational[-3, 2], Rational[3, 2], Rational[-3, 2]}}, {{-1.5, 1.5, 
      1.5}, {-1.5, 1.5, -1.5}}]]}, 
   {RGBColor[1, 0, 0], Line3DBox[{{-3, 3, -3}, {-3, -3, -3}}]}, 
   {RGBColor[1, 0, 0], 
    Line3DBox[
     NCache[{{-3, 3, -3}, {
       Rational[-3, 2], Rational[3, 2], Rational[-3, 2]}}, {{-3, 
       3, -3}, {-1.5, 1.5, -1.5}}]]}, 
   {RGBColor[1, 0, 0], 
    Line3DBox[
     NCache[{{Rational[-3, 2], Rational[3, 2], Rational[-3, 2]}, {
       Rational[-3, 2], Rational[-3, 2], Rational[-3, 2]}}, {{-1.5, 
      1.5, -1.5}, {-1.5, -1.5, -1.5}}]]}, 
   {RGBColor[1, 0, 0], Line3DBox[{{-3, -3, 3}, {-3, -3, -3}}]}, 
   {RGBColor[1, 0, 0], 
    Line3DBox[
     NCache[{{-3, -3, 3}, {
       Rational[-3, 2], Rational[-3, 2], Rational[3, 2]}}, {{-3, -3, 
       3}, {-1.5, -1.5, 1.5}}]]}, 
   {RGBColor[1, 0, 0], 
    Line3DBox[
     NCache[{{Rational[-3, 2], Rational[-3, 2], Rational[3, 2]}, {
       Rational[-3, 2], Rational[-3, 2], Rational[-3, 2]}}, {{-1.5, -1.5, 
      1.5}, {-1.5, -1.5, -1.5}}]]}, 
   {RGBColor[1, 0, 0], 
    Line3DBox[
     NCache[{{-3, -3, -3}, {
       Rational[-3, 2], Rational[-3, 2], 
        Rational[-3, 2]}}, {{-3, -3, -3}, {-1.5, -1.5, -1.5}}]]}},
  Boxed->False,
  ViewPoint->{1.3, -2.4, 2.},
  ViewVertical->{0., 0., 1.}]], "Output",
 CellChangeTimes->{{3.8366958510975103`*^9, 3.836695861428585*^9}},
 CellLabel->
  "Out[237]=",ExpressionUUID->"edeb71c9-fe5b-41a6-8f55-5d7b0e9bd992"]
}, Open  ]]
},
WindowSize->{770, 855},
WindowMargins->{{Automatic, 158}, {Automatic, 0}},
FrontEndVersion->"12.0 for Mac OS X x86 (64-bit) (April 8, 2019)",
StyleDefinitions->"Default.nb"
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{}
*)
(*CellTagsIndex
CellTagsIndex->{}
*)
(*NotebookFileOutline
Notebook[{
Cell[1488, 33, 171, 4, 35, "Text",ExpressionUUID->"37d9c6ba-d108-4ec6-99ee-da8d4b15b54b"],
Cell[1662, 39, 223, 6, 30, "Input",ExpressionUUID->"a8508b61-a1ae-4d0f-b9dc-0d98427171af"],
Cell[1888, 47, 191, 4, 35, "Text",ExpressionUUID->"dc3a0b01-9f33-4e09-bd6a-eda9466e803c"],
Cell[2082, 53, 2885, 101, 346, "Input",ExpressionUUID->"2d1fe327-7f51-411f-8117-0df1f9df4299"],
Cell[4970, 156, 183, 4, 35, "Text",ExpressionUUID->"22d48124-ccd6-45b8-9e83-ec51f69c9905"],
Cell[5156, 162, 202, 4, 30, "Input",ExpressionUUID->"8f3ca632-b6dd-42f5-947d-6bf959bc46ae"],
Cell[5361, 168, 302, 6, 35, "Text",ExpressionUUID->"84fbfbbd-a4c0-4549-8056-a7424defe810"],
Cell[5666, 176, 8388, 279, 346, "Input",ExpressionUUID->"e99506f6-b3ea-410d-a9c0-c064cfa803c6"],
Cell[14057, 457, 248, 5, 35, "Text",ExpressionUUID->"be59ae6e-04c5-4d32-9ea0-1a4d8e12f2ea"],
Cell[14308, 464, 8442, 256, 682, "Input",ExpressionUUID->"5362201a-5384-4659-bc9a-5cade5c05927"],
Cell[22753, 722, 297, 8, 196, "Text",ExpressionUUID->"d35792fe-bfc0-4a4f-8740-18b63cbd32aa"],
Cell[23053, 732, 260, 7, 311, "Text",ExpressionUUID->"7c9f043e-9912-49ea-8715-f7290f898a56"],
Cell[23316, 741, 177, 4, 35, "Text",ExpressionUUID->"89262654-c7e3-4a1f-bb16-ae00bf006708"],
Cell[CellGroupData[{
Cell[23518, 749, 726, 14, 73, "Input",ExpressionUUID->"f11e62c9-e2fd-4428-9e5b-e30e5cb0071e"],
Cell[24247, 765, 4967, 119, 408, "Output",ExpressionUUID->"edeb71c9-fe5b-41a6-8f55-5d7b0e9bd992"]
}, Open  ]]
}
]
*)

(* End of internal cache information *)

(* NotebookSignature ju0mIpbNoawCZA1UFoysWsb6 *)
